<?php
/**
 * Class for the Post Requests page.
 *
 * @package Freesoul Deactivate Plugins
 */

defined( 'ABSPATH' ) || exit; // Exit if accessed directly.

class FDP_Post_Request_Page extends FDP_Custom_Rows_Page {
  public $urls;
  public $home_url;
  public $section_id;

  public function before_section( $page_slug ){
    wp_nonce_field( 'eos_dp_pro_get_post_actions','eos_dp_pro_get_post_actions' );
    wp_nonce_field( 'eos_dp_pro_record_post_action_start','eos_dp_pro_record_post_action_start' );
    wp_nonce_field( 'eos_dp_pro_record_post_action_stop','eos_dp_pro_record_post_action_stop' );
    add_filter( 'fdp_submit_button_class',function( $class ){
      return '';
    } );
    $this->section_id = 'eos-dp-by-post-request-section';
    $this->urls = eos_dp_get_option( 'eos_dp_by_post_request' );
    if( !$this->urls || empty( $this->urls ) || !is_array( $this->urls ) ){
  		$this->urls = array( array( 'url' => '','plugins' => '' ) );
  	}
  	else{
  		$this->urls[] = array( 'url' => '','plugins' => '' );
  	}
  	$this->home_url = get_home_url();
    ?>
    <style>
    .eos-dp-action-name{position:absolute;top:0;font-size:12px;background:transparent !important;border:none !important}
  	#eos-dp-setts .eos-dp-post-name-wrp{padding-top:20px;padding-bottom:12px;width:340px}
  	#eos-dp-setts .eos-dp-ajax-actions{position:absolute;top:18px;<?php echo is_rtl() ? 'right' : 'left'; ?>:30px}
  	#eos-dp-setts .eos-dp-post-name-wrp .fdp-acts-wrp{position:absolute;top:12px;<?php echo is_rtl() ? 'left' : 'right'; ?>:-20px}
  	#eos-dp-setts .dashicons{font-size:30px}
    #eos-dp-setts input.eos-dp-action-name:focus{border-color:transparent;outline:none;box-shadow:none}
    </style>
    <div class="fdp-wrp">
      <h2><?php esc_html_e( 'Uncheck the plugins you want to disable by Post request.','eos-dp-pro' ); ?></h2>
      <p><?php esc_html_e( 'Use * if you want to anonymize the Post values, and & to add more Post elements.','eos-dp-pro' ); ?></p>
      <p><?php esc_html_e( 'E.g. first_name=*&last_name=* will match $_POST = array( "first_name" = "John","last_name" = "Green" ), $_POST = array( "first_name" = "Tim","last_name" = "Brown" )...','eos-dp-pro' ); ?></p>
  		<p><span class="dashicons dashicons-warning"></span><?php _e( 'It will work only for Post requests','eos-dp-pro' ); ?></p>
    </div>
    <?php
  }
  public function tableBody( $page_slug ){
    $data = eos_dp_pro_get_option( 'eos_dp_pro_post_setts' );
  	$action_names = eos_dp_pro_get_option( 'eos_dp_pro_post_action_names' );
  	$action_names = json_decode( str_replace( '\\','',$action_names ),true );
  	$actions = array();
  	if( $data && '' !== $data ){
  		$actions = json_decode( str_replace( '\\','',$data ),true );
  		$actions = $actions && is_array( $actions ) && !empty( $actions ) ? $actions : array();
  	}
  	$ajaxTheme = eos_dp_pro_get_option( 'eos_dp_pro_post_theme' );
    $row = 0;
    foreach( $actions as $action => $plugins ){
      $action_key = sanitize_key( str_replace( ',','--',$action ) );
    ?>
      <tr class="eos-dp-ajax eos-dp-post-row">
        <td class="eos-dp-post-name-wrp">
          <span class="eos-dp-not-active-wrp"><input title="<?php _e( 'Activate/deactivate all plugins when this Post request fires','eos-dp-pro' ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
          <input type="text" class="eos-dp-action-name" placeholder="<?php esc_attr_e( 'Action name','eos-dp-pro' ); ?>" value="<?php echo isset( $action_names[$action] ) ? esc_attr( $action_names[$action] ) : esc_attr( $action ); ?>"/>
          <input type="text" class="eos-dp-ajax-actions" value="<?php echo esc_attr( $action ); ?>"/>
          <div class="fdp-acts-wrp">
            <span class="eos-dp-delete-ajax dashicons dashicons-trash hover" style="font-size:30px" title="<?php _e( 'Delete','eos-dp-pro' ); ?>"></span>
            &nbsp;&nbsp;<a class="eos-dp-copy" href="#"><span class="dashicons dashicons-admin-page" style="font-size:30px"></span></a>
            &nbsp;&nbsp;<a class="eos-dp-paste" href="#"><span class="dashicons dashicons-category" style="font-size:30px"></span></a>
            <span class="dashicons dashicons-move" style="margin:0 6px" title="<?php _e( 'Move it up to assign higher priority','eos-dp-pro' ); ?>"></span>
            <span class="eos-dp-x-space"></span>
          </div>
        </td>
      <?php
      $k = 0;
      foreach( $this->active_plugins as $plugin ){
        if( in_array( $plugin,array_keys( $this->plugins_by_dirs ) ) ){
          $active = !in_array( $plugin,explode( ',',$plugins ) ) ? true : false;
          ?>
          <td class="center<?php echo $active ? ' eos-dp-active' : ''; ?>" data-path="<?php echo esc_attr( $plugin ); ?>">
            <div class="eos-dp-td-chk-wrp eos-dp-td-ajax-chk-wrp">
              <input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?>" type="checkbox"<?php echo $active ? ' checked' : ''; ?> />
            </div>
          </td>
        <?php
        ++$k;
        }
      } ?>
      <td class="center<?php echo !isset( $ajaxTheme[$action] ) || $ajaxTheme[$action] ? ' eos-dp-active' : ''; ?>">
        <div class="eos-dp-td-chk-wrp eos-dp-td-ajax-chk-wrp">
          <input class="eos-dp-row-theme eos-dp-col-<?php echo $k + 1; ?>" data-checked="checked" type="checkbox" checked />
        </div>
      </td>
    </tr>
      </tr>
      <?php ++$row;
    }
    ?>
    <tr class="eos-dp-ajax eos-dp-post-row eos-hidden">
      <td class="eos-dp-post-name-wrp">
        <span class="eos-dp-not-active-wrp"><input title="<?php _e( 'Activate/deactivate all plugins when this Post request fires','eos-dp-pro' ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
        <input type="text" class="eos-dp-action-name" placeholder="<?php esc_attr_e( 'Action name','eos-dp-pro' ); ?>" value="" />
        <input type="text" class="eos-dp-ajax-actions" value="" />
        <div class="fdp-acts-wrp">
          <span class="eos-dp-delete-ajax dashicons dashicons-trash hover" style="font-size:30pxx" title="<?php _e( 'Delete','eos-dp-pro' ); ?>"></span>
          &nbsp;&nbsp;<a class="eos-dp-copy" href="#"><span class="dashicons dashicons-admin-page" style="font-size:30px"></span></a>
          &nbsp;&nbsp;<a class="eos-dp-paste" href="#"><span class="dashicons dashicons-category" style="font-size:30px"></span></a>
          <span class="dashicons dashicons-move" style="margin:0 6px" title="<?php _e( 'Move it up to assign higher priority','eos-dp-pro' ); ?>"></span>
          <span class="eos-dp-x-space"></span>
        </div>
      </td>
    <?php
    $k = 0;
    foreach( $this->active_plugins as $plugin ){
      if( in_array( $plugin,array_keys( $this->plugins_by_dirs ) ) ){
      ?>
      <td class="center eos-dp-active">
        <div class="eos-dp-td-chk-wrp eos-dp-td-ajax-chk-wrp">
          <input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?>" type="checkbox" checked />
        </div>
      </td>
    <?php ++$k; } } ?>
    <td class="center eos-dp-active">
      <div class="eos-dp-td-chk-wrp eos-dp-td-ajax-chk-wrp">
        <input class="eos-dp-row-theme eos-dp-col-<?php echo $k + 1; ?>" data-checked="checked" type="checkbox" checked />
      </div>
    </td>
    </tr>
    <?php
    add_action( 'fdp_after_table',function(){
      ?>
      <div id="eos-dp-ajax-actions">
        <button class="eos-dp-add-ajax"><?php esc_html_e( 'Add action','eos-dp-pro' ); ?></button>
      </div>
      <?php
      require_once EOS_DP_PRO_PLUGIN_DIR.'/admin/templates/partials/fdp-actions-recorder.php';
    } );
  }
}
