jQuery(document).ready(function($){
	$('#eos-rh-get-hooks').on('click',function(){
		var btn = $(this),plugin_path = '';
		btn.addClass('eos-dp-progress');
		$('.fdp-active-plugin').not('.eos-active').each(function(){
			plugin_path += ';pn:' + $(this).attr('data-path');
		});
		$('#eos-rh-hooks').fadeOut();
		$('#eos-rh-hooks-lev2').fadeOut();
		$.ajax({
			type : "POST",
			url : eos_rh.ajaxurl,
			data : {
				"uniqid" : $('#eos_rh_get_hooks_uniqid').val(),
				"post_id" : $('#eos-rh-dropdown').val(),
				"plugins" : plugin_path,
				"theme" : $('.fdp-theme').hasClass('eos-active'),
				"wp_core" : $('.fdp-wp-core').hasClass('eos-active'),
				"action" : "eos_dp_pro_get_hooks"
			},
			success : function (response) {
				if('' !== response){
					response = response.replace('<!-- {{eos-remove-hooks-start}} -->','').replace('<!-- {{eos-remove-hooks-end}} -->','');
					var json = $.parseJSON(response),
						html = '<option id="fdp-empty-opt" value="0">' + eos_rh.select_option + '</option>';
					$.each(json,function(a,b){
						html += '<option id="' + a + '" value="' + JSON.stringify(b).split('"').join('\'') + '">' + a + '</option>';
					});
					$('#eos-rh-hooks-sel').html(html);
					$('#eos-rh-hooks').fadeIn();
					btn.removeClass('eos-dp-progress');
				}
			}
		});
	});
	$('#eos-rh-hooks-sel').on('change',function(){
		if(null === $(this).val()) return;
		var json = $.parseJSON($(this).val().split("'").join('"')),
			html = '',
			n = 0;
		$.each(json,function(priority,hook){
			html += '<outgroup label="' + Object.keys(hook)[n] +'">';
			$.each(hook,function(a,b){
				if('object' === typeof(b.function)){
					var hook_keys = Object.keys(hook),
						hook_key = hook_keys[hook_keys.length - 1],
						function_name = 'string' !== typeof(hook[hook_key].function) && hook[hook_key].function.length > 1 ? hook[hook_key].function.join(',') : hook[hook_key].function;
				}
				else{
					var function_name = b.function;
				}
				html += '<option value="' + function_name + '" data-args="' + b.accepted_args + '"' +  ' data-priority="' + priority + '">' + function_name + '</option>';
			});
			html += '</outgroup>';
			++n;
		});
		$('#eos-rh-hooks-lev2-sel').html(html);
		$('#eos-rh-hooks-lev2').fadeIn();
	});
	$('#eos-rh-functions-auto-sel').on('keyup click',function(){
		var option = $('[id^="' + $(this).val() + '"]');
		if(option.length > 0){
			$('#eos-rh-hooks-sel').val(option.eq(0).val()).trigger('change');
		}
	});
	$('#eos-rh-remove').on('click',function(){
		var post_id = $('#eos-rh-dropdown').val(),
			hook_name = $('#eos-rh-hooks-sel').find('option:selected').text(),
			function_sel = $('#eos-rh-hooks-lev2-sel').find('option:selected'),
			hook_function = function_sel.text(),
			table = $('#fdp-hooks'),
			tr_id = 'fdp' + eos_dp_string_to_hash(hook_name + hook_function),
			new_row = '',
			hook_row = $('#' + tr_id),
			where_sel = $('#eos-rh-hooks-where').find('option:selected'),
			where = where_sel.text();
		if(hook_row.length < 1){
			new_row += '<tr id="' + tr_id + '" data-post_id="' + post_id + '" data-hook="' + hook_name + '" data-args="' + function_sel.attr('data-args') + '" data-priority ="' + function_sel.attr('data-priority') + '" data-where="' + where_sel.val() + '">';
			new_row += '<td class="fdp-hook-name">' + hook_name + '</td>';
			new_row += '<td class="fdp-hook-functions">' + hook_function + '</td>';
			new_row += '<td class="fdp-hook-where">' + where + '<span class="fdp-delete-row hover dashicons dashicons-trash"></span></td>';
			new_row += '</tr>';
			table.find('tbody').append(new_row);
		}
	});
	$('.fdp-hook-part').on('click',function(){
		$(this).toggleClass('eos-active');
	});
	$('.fdp-active-all-plugin').on('click',function(){
		$('#fdp-active-plugins .fdp-hook-part').addClass('eos-active');
	});
	$('.fdp-active-no-plugin').on('click',function(){
		$('#fdp-active-plugins .fdp-hook-part').removeClass('eos-active');
	});
	$('#fdp-hooks').on('click','.fdp-delete-row',function(){
		$(this).closest('tr').remove();
	});
	$('#fdp-save-hooks').on('click',function(){
		var btn = $(this),data = {},obj_string = '';
		btn.addClass('eos-dp-progress');
		$('#fdp-hooks tr').each(function(){
			var tr = $(this),
				post_id = tr.attr('data-post_id'),
				hook_name = tr.find('.fdp-hook-name').text(),
				hook_functions = tr.find('.fdp-hook-functions').text(),
				hook_where = tr.attr('data-where');
			if('undefined' !== hook_name && '' !== hook_name){
				var key_hash = eos_dp_string_to_hash(hook_name + hook_functions);
				data[hook_name + '_fdp_hook_id_' + key_hash] = {'function' : hook_functions,'args' : tr.attr('data-args'),'priority' : tr.attr('data-priority'),'where' : hook_where,'post_id' : post_id};
			}
		});
		data['nonce'] = $('#fdp_setts_nonce').val();
		data['opts_key'] = eos_rh.opts_key;
		var xhr = fdp_setts_sendData(data,eos_rh.action);
		xhr.onload = function(){
			if('1' !== xhr.response){
				alert('Something went wrong during the saving process.');
			}
			btn.removeClass('eos-dp-progress');
		}
	});
});
function fdp_setts_sendData(data,action){
	var xhr = new XMLHttpRequest(),fd = new FormData();
	fd.append('data',JSON.stringify(data));
	xhr.open("POST",eos_rh.ajaxurl + '?action=' + action,true);
	xhr.send(fd);
	return xhr;
}
