<?php
//Deprecated since Freesoul Deactivate Pugins v. 1.9.0

defined( 'ABSPATH' ) || exit;

if( !current_user_can( 'activate_plugins' ) && !current_user_can( 'fdp_plugins_viewer' ) ){
?>
  <h2><?php _e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
  <?php
  return;
}
$active_plugins = eos_dp_active_plugins();
$plugins = eos_dp_get_plugins();
$desktop = eos_dp_get_option( 'eos_dp_desktop' );
wp_nonce_field( 'eos_dp_desktop_setts', 'eos_dp_desktop_setts' );
eos_dp_alert_plain_permalink();
eos_dp_navigation();
?>
<section id="eos-dp-desktop-section" class="eos-dp-section">
  <h2><span class="dashicons dashicons-desktop"></span><?php _e( 'Desktop version.','eos-dp' ); ?></h2>
  <p><?php _e( 'The plugins you uncheck here will always be disabled on desktop devices, no matter which pages and what you set on other options','eos-dp' ); ?></p>
  <p><strong><?php _e( 'Be sure you have a server cache plugin that distinguishes between desktop and mobile.','eos-dp' ); ?></strong></p>
  <div style="margin-bottom:12px;margin-top:32px">
    <span class="eos-dp-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px;margin:0" type="checkbox"></span>
    <span class="eos-dp-legend-txt"><?php _e( 'Plugin active','eos-dp' ); ?></span>
    <span class="eos-dp-not-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px;margin:0" type="checkbox" checked=""></span>
    <span class="eos-dp-legend-txt"><?php _e( 'Plugin not active','eos-dp' ); ?></span>
  </div>
  <div style="margin:32px 0 16px 0">
    <span id="fdp-select-all-single-post" class="button"><?php _e( 'Enable All','eos-dp' ); ?></span>
    <span id="fdp-unselect-all-single-post" class="button"><?php _e( 'Disable All','eos-dp' ); ?></span>
  </div>
  <div id="eos-dp-wrp" style="margin-top:32px">
    <table id="eos-dp-setts">
      <tbody>
      <?php
      $n = 0;
      foreach( $active_plugins as $p ){
        if( isset( $plugins[$p] ) ){
          $plugin_name = strtoupper( str_replace( '-',' ',dirname( $p ) ) );
          $checked = $desktop && in_array( $p,$desktop ) ? '' : ' checked';
          $details_url = add_query_arg(
            array(
              'tab' => 'plugin-information',
              'plugin' => dirname( $p ),
              'TB_iframe' => true,
              'eos_dp' => $p,
              'eos_dp_info' => 'true'
            ),
            admin_url( 'plugin-install.php' )
          );
          ?>
          <tr>
            <td class="eos-dp-desktop-chk-col <?php echo '' !== $checked ? 'eos-dp-active' : ''; ?>">
              <div class="eos-dp-td-chk-wrp">
                <input id="eos-dp-desktop-<?php echo $n + 1; ?>" class="eos-dp-desktop" title="<?php printf( __( 'Activate/deactivate %s everywhere on desktop','eos-dp' ),esc_attr( $plugin_name ) ); ?>" data-path="<?php echo $p; ?>" type="checkbox"<?php echo $checked; ?> />
              </div>
            </td>
            <td class="eos-dp-name-td"><span class="dashicons dashicons-admin-plugins"></span><a title="<?php _e( 'View details','eos-dp' ); ?>" target="_blank" class="eos-dp-no-decoration" href="<?php echo esc_url( $details_url ); ?>"><?php echo esc_html( $plugin_name ); ?></a></td>
          </tr>
          <?php
          ++$n;
        }
      }
      ?>
      </tbody>
    </table>
  </div>
  <div>
  <?php
  if( !defined( 'EOS_SCFM_PLUGIN_BASE_NAME' ) ){
    $slug = 'specific-content-for-desktop';
    if ( !is_dir( WP_PLUGIN_DIR . '/specific-content-for-desktop' ) ) {
      $action = 'install-plugin';
      $url = wp_nonce_url(
        add_query_arg(
          array(
            'action' => $action,
            'plugin' => $slug
          ),
          admin_url( 'update.php' )
        ),
        'install-plugin_'.$slug
      );
      $msg = __( 'If you need to disable plugins only on specific pages for desktop, you should also install "Specific Content For Mobile"','eos-dp' );
      $msg .= sprintf( __( '%sInstall Specific Content For Mobile%s','eos-dp' ),' <a class="button" href="'.$url.'" target="_blank">','</a>' );
    }
    else{

      $plugin = 'specific-content-for-desktop/specific-content-for-desktop.php';
      $action = 'activate';
      $url = sprintf( admin_url( 'plugins.php?action='.$action.'&plugin=%s&plugin_status=all&paged=1&s' ),$plugin );
      $url = wp_nonce_url( $url,$action.'-plugin_'.$plugin );
      $msg = __( 'If you need to disable plugins on desktop only on specific pages, you should activate "Specific Content For Desktop"','eos-dp' );
      $msg .= sprintf( __( '%sActivate Specific Content For Desktop%s','eos-dp' ),' <a class="button" href="'.$url.'" target="_blank">','</a>' );
    }
    ?>
    <p><?php echo wp_kses( $msg,array( 'a' => array( 'class' => array(),'href' => array(),'target' => array() ) ) ); ?></p>
    <?php
  }
  ?>
  </div>
  <?php
  if( current_user_can( 'activate_plugins' ) ){
    eos_dp_save_button();
  }
  ?>
</section>
