<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

function eos_dp_pro_autoload_callback(){
  if( !current_user_can( 'activate_plugins' ) && function_exists( 'view_fdp_settings' ) ){
  ?>
    <h2><?php esc_html_e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
    <?php
    return;
  }
  $opts = eos_dp_pro_get_option( 'eos_dp_noautoload' );
  $opts = $opts ? json_decode( stripslashes( $opts ),true ) : array();
  $step = isset( $_GET['step'] ) ? absint( $_GET['step'] ) : 200;
  wp_nonce_field( 'fdp_autoload_nonce','fdp_autoload_nonce' );
  $all_options = eos_dp_get_autoload_options();
  $total_size = round( array_sum( array_values( $all_options ) )/1000,1 );
  if( $opts && is_array( $opts ) ){
    foreach( $opts as $key => $value ){
      if( isset( $all_options[$key] ) ){
        unset( $all_options[$key] );
      }
    }
    $all_options = array_merge( $all_options,$opts );
  }
  $removed_size = round( array_sum( array_values( $opts ) )/1000,1 );
  $pages = absint( count( $all_options )/$step );
  $uniqid = uniqid();
  if( !isset( $_GET['fdp_order_by'] ) || 'size' === sanitize_text_field( $_GET['fdp_order_by'] ) ){
    arsort( $all_options );
  }
  else{
    if( isset( $_GET['fdp_order'] ) && 'asc' === sanitize_text_field( $_GET['fdp_order'] ) ){
      krsort( $all_options );
    }
    else{
      ksort( $all_options );
    }
  }
	eos_dp_navigation();
  $url = admin_url( 'admin.php?page=eos_dp_pro_autoload' );
  $left = is_rtl() ? 'right' : 'left';
	?>
  <style>
  #eos-dp-setts th{padding:10px}
  #eos-dp-setts th,#eos-dp-setts td{text-align:center;vertical-align:center}
  #eos-dp-setts td:first-child{text-align:<?php echo $left; ?>;padding-<?php echo $left; ?>:10px}
  #eos-dp-autoload-section .fdp-autoload-over-limits{padding:0 4px;display:inline-block;font-weight:bold;background-color:red !important;color:yellow !important}
  #eos-dp-autoload-section .eos-dp-td-chk-wrp,#eos-dp-autoload-section #eos-dp-setts td .eos-dp-td-chk-wrp input{display:inline-block;width:100%}
  .fdp-autoload-row a{color:inherit;text-decoration:none}
  </style>
  <section id="eos-dp-autoload-section" class="eos-dp-section fdp-pro-section">
    <div style="display:inline-block">
      <div class="tablenav-pages" style="max-width:1200px;max-width:calc(100vw - 200px)">
        <span class="fdp-filter-autoload button eos-active" onclick="fdp_autoload_update_filter(1,this);">1</span>
        <?php
        for( $p=2;$p<$pages;++$p ){ ?>
        <span class="fdp-filter-autoload button" onclick="fdp_autoload_update_filter(<?php echo $p; ?>,this);"><?php echo $p; ?></span>
        <?php } ?>
      </div>
    </div>
    <h2 class="left"><?php esc_html_e( "Uncheck the options that should not be autoloaded.","eos-dp-pro" ); ?></h2>
    <p><?php esc_html_e( 'Usually, you have performance issues when the total size of the autoloaded options exceed 900 kB','eos-dp-pro' ); ?></p>
    <p class="left"><?php esc_html_e( "Click on the question marks next to the option names to see who calls that option on the homepage.","eos-dp-pro" ); ?></p>
    <div id="fdp-autoload-totals">
      <p>
        <span><?php esc_html_e( 'Total size:','eos-dp-pro' ); ?> <span<?php echo $total_size > 900 ? ' class="fdp-autoload-over-limits"' : ''; ?>><span id="fdp-autoload-total-size" style="color:inherit"><?php echo esc_html( $total_size ); ?></span> kB</span></span>
        <span><?php esc_html_e( 'Removed:','eos-dp-pro' ); ?> <span id="fdp-autoload-removed-size"><?php echo esc_html( $removed_size ); ?></span> kB</span>
      </p>
    </div>
    <table id="eos-dp-setts">
      <tr>
        <th><?php esc_html_e( 'Option','eos-dp-pro' );
          if( isset( $_GET['fdp_order'] ) && 'asc' === sanitize_text_field( $_GET['fdp_order'] ) ){?>
          <a href="<?php echo add_query_arg( array( 'fdp_order_by' => 'option' ),$url ); ?>" class="dashicons dashicons-arrow-up"></a>
          <?php }else{ ?>
          <a href="<?php echo add_query_arg( array( 'fdp_order_by' => 'option','fdp_order' =>'asc' ),$url ); ?>" class="dashicons dashicons-arrow-down"></a></th>
          <?php } ?>
        <th><?php esc_html_e( 'Size [kB]','eos-dp-pro' ); ?> <a href="<?php echo add_query_arg( array( 'fdp_order_by' => 'size' ),$url ); ?>" class="dashicons dashicons-arrow-down"></a> </th>
        <th><?php esc_html_e( 'Autoload','eos-dp-pro' ); ?></th>
      </tr>
      <?php
      $n = 1;
      foreach( $all_options as $k => $size ){
      $disabled = $k && !empty( $k ) && false !== strpos( $k,'eos_dp_' ) || in_array( $k,array( 'eos_post_types_plugins','rewrite_rules' ) );
      $checked = !isset( $opts[$k] ) ? ' checked' : '';
      ?>
      <tr class="fdp-autoload-row fdp-autoload-<?php echo 1 + absint( $n/$step ) ;echo absint( $n/$step ) > 1 ? ' eos-hidden' : '';echo $disabled ? ' eos-no-events' : ''; ?>" data-option="<?php echo esc_attr( $k ); ?>" data-size="<?php echo esc_attr( $size ); ?>">
        <td><?php echo esc_html( $k ); ?> <span title="<?php echo esc_attr( sprintf( __( 'Click to see who calls %s on the homepage','eos-dp-pro' ),$k ) ); ?>" class="fdp-option-help dashicons dashicons-editor-help hover"></span></td>
        <td><?php echo round( $size/1000,2 ) > 0 ? round( $size/1000,2 ) : round( $size/1000,3 ); ?></td>
        <td class="fdp-autoload-thick <?php echo ' checked' === $checked ? 'eos-dp-active' : 'autoload-changed'; ?>">
          <div class="eos-dp-td-chk-wrp">
            <input id="fdp-<?php echo $k; ?>" class="fdp-autoload-chk" type="checkbox" data-key="<?php echo esc_attr( $k ); ?>" value="1"<?php echo $checked; ?> />
          </div>
        </td>
      </tr>
      <?php
      ++$n;
    } ?>
    </table>
  </section>
  <?php
  if( current_user_can( 'activate_plugins' ) ){
    eos_dp_save_button();
  }
  ?>
  <div id="eos-dp-overlap"></div>
  <script id="fdp-autoload">
  function fdp_autoload_update_filter(n,btn){
    jQuery('.fdp-autoload-row').addClass('eos-hidden');jQuery('.fdp-autoload-' + n).removeClass('eos-hidden');
    jQuery('.fdp-filter-autoload').removeClass('eos-active');
    jQuery(btn).addClass('eos-active');
  }
  function fdp_whois_option_help(){
    var fdp_option_helps = document.getElementsByClassName('fdp-option-help'),n=0,tds = document.getElementsByClassName('fdp-autoload-thick');
    for(n;n<fdp_option_helps.length;++n){
      fdp_option_helps[n].addEventListener('click',function(){
        var row = jQuery(this).closest('.fdp-autoload-row'),option = row.attr('data-option');
        row.addClass('eos-dp-progress');
        jQuery.ajax({
          type : "POST",
          url : '<?php echo admin_url( 'admin-ajax.php' ); ?>',
          data : {
            "headers" : eos_dp_js.headers,
            "option" : option,
            "nonce" : document.getElementById('fdp_autoload_nonce').value,
            "action" : 'eos_dp_pro_whois_option'
          },
          success : function (response) {
            row.removeClass('eos-dp-progress');
            alert(response);
          }
        });
        eos_dp_send_ajax(jQuery(this),);
      });
    }
    for(n=0;n<tds.length;++n){
      tds[n].addEventListener('click',function(){
        jQuery(this).addClass('autoload-changed');
        var total_size = jQuery('#fdp-autoload-total-size'),removed = jQuery('#fdp-autoload-removed-size'),changed_size = parseFloat(jQuery(this).prev().text());
        changed_size = jQuery(this).hasClass('eos-dp-active')  ? -1*changed_size : changed_size;
        total = parseFloat(total_size.text()) + changed_size;
        if(total > 900){
          total_size.parent().addClass('fdp-autoload-over-limits');
        }
        else{
          total_size.parent().removeClass('fdp-autoload-over-limits');
        }
        total_size.text(Math.round(10*total)/10);
        removed.text(Math.round(10*(parseFloat(removed.text()) - changed_size))/10);
      });
    }
  }
  fdp_whois_option_help();
  document.getElementsByClassName('eos-dp-save-eos_dp_pro_autoload')[0].addEventListener('click',function(){
    if('function' === typeof(eos_dp_send_ajax)){
      jQuery('.eos-dp-opts-msg').addClass('eos-hidden');
      var noautoload = {},autoload = '';
      jQuery('.fdp-autoload-row').each(function(){
        var parent = jQuery(this).find('.eos-dp-td-chk-wrp').parent();
        if(!parent.hasClass('eos-dp-active')){
          noautoload[jQuery(this).find('td').first().text()] = this.dataset.size;
        }
        else if(parent.hasClass('eos-dp-active') && parent.hasClass('autoload-changed') ){
          autoload += jQuery(this).attr('data-option') + ',';
        }
      });
      eos_dp_send_ajax(jQuery(this),{
        "noautoload" : JSON.stringify(noautoload),
        "autoload" : autoload,
        "nonce" : document.getElementById('fdp_autoload_nonce').value,
        "action" : 'eos_dp_pro_autoload'
      });
    }
  });
  </script>
	<?php
}

//Return all autooloaded options
function eos_dp_get_autoload_options(){
	global $wpdb;
	$suppress      = $wpdb->suppress_errors();
	$alloptions_db = $wpdb->get_results( "SELECT option_name, length(option_value) AS option_value_length FROM $wpdb->options WHERE autoload = 'yes'" );
	$wpdb->suppress_errors( $suppress );
	$alloptions = array();
	foreach ( (array) $alloptions_db as $o ) {
		$alloptions[$o->option_name] = $o->option_value_length;
	}
  return $alloptions;
}

function eos_dp_get_orphan_post_meta(){
  global $wpdb;
  $suppress  = $wpdb->suppress_errors();
  $orphanes = $wpdb->get_results( "SELECT * FROM wp_postmeta LEFT JOIN wp_posts ON wp_posts.ID = wp_postmeta.post_id WHERE wp_posts.ID IS NULL" );
  $wpdb->suppress_errors( $suppress );
  foreach( $orphanes as $orphane ){
    $keys[] = $orphane->meta_key;
  }
  return $keys;
}
