<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//It adds the Bulk Actions section
function eos_dp_pro_bulk_actions_callback(){
	delete_site_transient( 'fdp_plugin_activated_notification' );
	$active_plugins = eos_dp_active_plugins();
	$plugins_by_dirs = eos_dp_get_plugins();
	$plugins_by_dirs = is_array( $plugins_by_dirs ) && !empty( $plugins_by_dirs ) ? array_keys( $plugins_by_dirs ) : array();
	$settings = eos_dp_pro_options_keys( true );
	eos_dp_navigation();
	?>
	<section id="fdp-bulk-actions">
		<h2><?php esc_html_e( 'Activate/deactivate a specific plugin in the selected options','eos-dp-pro' ); ?></h2>
		<table class="wp-list-table widefat fixed striped" style="margin-top:64px">
			<thead>
				<th><span class="dashicons dashicons-admin-plugins"></span><?php esc_html_e( 'Plugin','eos-dp-pro' ); ?></th>
				<th><span class="dashicons dashicons-edit"></span><?php esc_html_e( 'Action','eos-dp-pro' ); ?></th>
				<th><span class="dashicons dashicons-admin-generic"></span><?php esc_html_e( 'Options','eos-dp-pro' ); ?></th>
			</thead>
			<tbody>
				<td>
					<p>
						<select id="fdp-bulk-plugin">
							<option value="none"><?php esc_html_e( 'Select...','eos-dp-pro' ); ?></option>
							<?php
							foreach( $active_plugins as $plugin ){
								if( in_array( $plugin,$plugins_by_dirs ) ){
									$plugin_name = strtoupper( eos_dp_pro_get_plugin_name_by_slug( $plugin ) );
									?>
									<option value="<?php echo esc_attr( $plugin ); ?>"><?php echo esc_html( $plugin_name ); ?></option>
									<?php
								}
							}
							?>
						</select>
					</p>
				</td>
				<td>
					<p>
						<select id="fdp-bulk-action">
							<option value="none"><?php esc_html_e( 'Select...','eos-dp-pro' ); ?></option>
							<option value="activate"><?php esc_html_e( 'Activate','eos-dp-pro' ); ?></option>
							<option value="deactivate"><?php esc_html_e( 'Deactivate','eos-dp-pro' ); ?></option>
						</select>
					</p>
				</td>
				<td>
					<?php
					foreach( $settings as $k => $v ){
						if( in_array( $k,array( 'eos_dp_pro_ajax_setts','eos_dp_by_url','eos_dp_by_admin_url','eos_dp_admin_setts' ) ) ){
							if( !eos_dp_get_option( $k ) ) continue;
						}
					?>
						<p style="margin-bottom:32px">
							<input id="fdp-bulk-sett-<?php echo esc_attr( $k ); ?>" class="fdp-bulk-chk" value="<?php echo $k; ?>" type="checkbox" />
							<label><?php echo esc_html( $v ); ?></label>
						</p>
						<?php if( 'eos_dp_singles' === $k ){ ?>
							<div style="margin-top:-16px;margin-bottom:32px;margin-<?php echo is_rtl() ? 'right' : 'left'; ?>:20px">
							<?php
							$plugins_table = eos_dp_plugins_table();
							if( !empty( $plugins_table  ) ){
								foreach( $plugins_table as $pt  => $arr ){
									$postTypeObj = get_post_type_object( $pt );

									if( !in_array( $pt,array( 'attachment' ) ) && is_object( $postTypeObj ) && isset( $postTypeObj->public ) && $postTypeObj->public ){

										$labels = get_post_type_labels( $postTypeObj );
										$labels_name = isset( $labels->name ) ? $labels->name : $pt;
										?>
										<p><input class="fdp-bulk-singles-pt" type="checkbox" value="<?php echo esc_attr( $pt ); ?>" /><label><?php echo esc_html( $labels_name ); ?></label></p>
										<?php
									}
								}
							}
							?>
							</div>
							<?php } ?>
					<?php } ?>
				</td>
			</tbody>
		</table>
		<div style="margin-top:32px;margin-top:32px;position:fixed;bottom:10px;z-index: 99999;" >
			<?php if( current_user_can( 'activate_plugins' ) ){ ?>
			<span id="fdp-bulk-actions-submit" class="button" style="background:#253042;color:#fff"><?php esc_html_e( 'Execute bulk action','eos-dp-pro' ); ?></span>
			<?php } ?>
			<div id="fdp-success" class="eos-dp-notice notice notice-success eos-hidden" style="padding:10px"><?php esc_html_e( 'Done!','eos-dp-pro' ); ?></div>
			<div id="fdp-fail" class="eos-dp-notice notice notice-error eos-hidden" style="padding:10px" data-default_msg="<?php esc_attr_e( 'Something went wrong!','eos-dp-pro' ); ?>"></div>
	</section>
	<?php
	wp_nonce_field( 'fdp_bulk_actions_nonce','fdp_bulk_actions_nonce' );
	wp_enqueue_script( 'fdp-pro-bulk-actions',EOS_DP_PRO_PLUGIN_URL.'/admin/js/eos-dp-pro-bulk-actions.js',array(),true );
	wp_localize_script( 'fdp-pro-bulk-actions','fdp_bulk_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
}
