<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//It adds the Plugins Settings section
function eos_dp_pro_plugins_callback(){
  if( !current_user_can( 'activate_plugins' ) && !current_user_can( 'fdp_plugins_viewer' ) ){
	?>
		<h2><?php _e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
		<?php
		return;
	}
	$active_plugins = eos_dp_active_plugins();
	$plugins = eos_dp_get_plugins();
  $all_plugins = array_unique( array_keys( get_plugins() ) );
  sort( $all_plugins );
  require EOS_DP_PLUGIN_DIR.'/admin/eos-dp-plugins-info.php';
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	$opts = isset( $opts['plugins_setts'] ) ? $opts['plugins_setts'] : array();
  $fdp_opts_msg = sprintf( __( 'Remember that you can decide who can see the FDP setting pages in %sRole Manager%s.','eos-dp-pro' ),'<a href="'.admin_url( 'admin.php?page=eos_dp_roles_manager' ).'" target="_blank">','</a>' );
  $theads = array(
    'as' => array( __( 'Enable on autosuggestion','eos-dp-pro' ),__( 'Disable plugins that would make fail the autosuggestion, e.g plugins for maintenance and coming soon, which make redirects or add dynamic content to the pages.','eos-dp-pro' ),'plugins-checked' ),
    'u' => array( __( 'Update notification','eos-dp-pro' ),__( 'If you uncheck a specific plugin, WordPress will not show any update notification for that plugin.' ).'<br />'.$fdp_opts_msg,'format-status' ),
    'v' => array( __( 'Visibility in the page of plugins','eos-dp-pro' ),__( 'If you uncheck a specific plugin, WordPress will not show it in the page of plugins.','eos-dp-pro' ).'<br />'.$fdp_opts_msg,'visibility' )
  );
	eos_dp_navigation();
	?>
  <section id="eos-dp-plugins-section" class="eos-dp-section">
		<h2><?php _e( 'Plugin Settings.','eos-dp' ); ?></h2>
		<div id="eos-dp-wrp" style="margin-top:32px">
      <div>
        <a class="fdp-plugins-activation-filter fdp-current-link" data-state="all" href="#"><?php esc_html_e( 'All','eos-dp-pro' ); ?></a>
        <span> | </span>
        <a class="fdp-plugins-activation-filter" data-state="fdp-inactive-plugin" href="#"><?php esc_html_e( 'Active','eos-dp-pro' ); ?></a>
        <span> | </span>
        <a class="fdp-plugins-activation-filter" data-state="fdp-active-plugin" href="#"><?php esc_html_e( 'Inactive','eos-dp-pro' ); ?></a>
      </div>
			<table id="eos-dp-setts">
				<thead style="z-indexx:99">
          <?php ob_start(); ?>
          <tr style="text-transform:uppercase">
            <th style="position:sticky;top:0;z-index:99999999;background:inherit">
              <table style="width:100%">
                <tr><td><span class="dashicons dashicons-admin-plugins"></span></td></tr>
                <tr style="height:36px"><td><?php esc_html_e( 'Plugin','eos-dp-pro' ); ?></td></tr>
                <tr>
                  <td class="fdp-has-tooltip" style="position:relative">
                    <span class="dashicons"></span>
                    <div class="fdp-tooltip" style="max-width:300px;transform:translateY(20px);text-align:initial"></div>
                  </td>
                </tr>
              </table>
            </th>
          <?php foreach( $theads as $k => $arr ){ ?>
            <th id="fdp-<?php echo $k; ?>" style="position:sticky;top:0;z-index:99999999;background:inherit">
              <table>
                <tbody>
                  <tr><td><span class="dashicons dashicons-<?php echo $arr[2]; ?>"></span></td></tr>
                  <tr style="height:36px;vertical-align:middle"><td><?php echo esc_html( $arr[0] ); ?></td></tr>
                  <tr>
                    <td class="fdp-has-tooltip" style="position:relative">
                      <span class="dashicons dashicons-editor-help"></span>
                      <div class="fdp-tooltip" style="max-width:300px;transform:translateY(20px);text-align:initial"><?php echo wp_kses( $arr[1],array( 'br' => array(),'a' => array( 'href' => array(),'target' => array() ) ) ); ?></div>
                    </td>
                  </tr>
                </tbody>
              </table>
            </th>
          <?php } ?>
          </tr>
        </thead>
        <tbody>
				<?php
				$n = 0;
				foreach( $all_plugins as $p ){
					if( isset( $plugins[$p] ) ){
						$plugin_name = strtoupper( eos_dp_pro_get_plugin_name_by_slug( $p ) );
						$details_url = add_query_arg(
							array(
								'tab' => 'plugin-information',
								'plugin' => dirname( $p ),
								'TB_iframe' => true,
								'eos_dp' => $p,
								'eos_dp_info' => 'true'
							),
							admin_url( 'plugin-install.php' )
						);
						?>
						<tr class="fdp-<?php echo in_array( $p,$active_plugins ) ? 'active-plugin' : 'inactive-plugin'; ?>">
							<td class="eos-dp-name-td">
                <span class="dashicons dashicons-admin-plugins"></span>
                <a title="<?php _e( 'View details','eos-dp' ); ?>" target="_blank" class="eos-dp-no-decoration" href="<?php echo esc_url( $details_url ); ?>">
                  <?php echo esc_html( $plugin_name ); ?>
                </a>
              </td>
              <?php foreach( $theads as $k => $arr ){
              $checked = !isset( $opts[$k] ) || !isset( $opts[$k][sanitize_key( dirname( $p ) )] ) || $opts[$k][sanitize_key( dirname( $p ) )] ? true : false;
              if( in_array( $p,$maintenance_plugins ) && 'as' === $k ) $checked = false;
              ?>
                <td class="fdp-<?php echo $k;echo $checked ? ' eos-dp-active' : '';echo in_array( $p,$maintenance_plugins ) && 'as' === $k ? '" style="pointer-events:none' : ''; ?>">
                  <div class="eos-dp-td-chk-wrp">
                    <input id="<?php echo $k.'_'.sanitize_key( dirname( $p ) ); ?>" class="fdp-opt" type="checkbox" value="on"<?php echo $checked ? ' checked' : ''; ?> />
                  </div>
                </td>
              <?php } ?>
						</tr>
						<?php
						++$n;
					}
				}
				?>
				</tbody>
			</table>
		</div>
	<?php
	if( function_exists( 'eos_dp_save_button' ) && current_user_can( 'activate_plugins' ) ){
		eos_dp_save_button();
	}
	wp_nonce_field( 'fdp_plugins_setts_nonce','fdp_plugins_setts_nonce' );
	wp_enqueue_script( 'fdp-pro-plugins',EOS_DP_PRO_PLUGIN_URL.'/admin/js/eos-dp-pro-plugins.js',array(),true );
	wp_localize_script( 'fdp-pro-plugins','fdp_plugins_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'action' => 'eos_dp_pro_save_plugins_settings','opts_key' => 'eos_dp_plugins_setts' ) );
}
