<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//Show hooks globally removed in the website
function eos_dp_pro_removed_hooks_callback(){
  if( !current_user_can( 'activate_plugins' ) ){
  ?>
    <h2><?php esc_html_e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
    <?php
    return;
  }
  eos_dp_alert_plain_permalink();
  eos_dp_navigation();
  wp_nonce_field( 'eos_dp_global_hooks_nonce','eos_dp_global_hooks_nonce' );
  $opts = eos_dp_get_option( 'eos_dp_pro_main' );
  if( isset( $opts['fdp_hooks'] ) && !empty( $opts['fdp_hooks'] ) ){
    ?>
    <h2 style="margin-top:32px"><?php esc_html_e( 'Removed hooks','eos-dp-pro' ); ?></h2>
    <table id="fdp-site-global-view-hooks" class="wp-list-table widefat fixed striped table-view-list">
      <thead>
        <tr>
          <th><?php esc_html_e( 'Name','eos-dp-pro' ); ?></th>
          <th><?php esc_html_e( 'Function','eos-dp-pro' ); ?></th>
          <th><?php esc_html_e( 'Priority','eos-dp-pro' ); ?></th>
          <th><?php esc_html_e( 'Removed in','eos-dp-pro' ); ?></th>
        </tr>
      </thead>
      <tbody>
      <?php
      foreach( $opts['fdp_hooks'] as $post_id => $hooks){
        if( 0 === absint( $post_id ) ) continue;
        $removed_hooks = json_decode( stripslashes( sanitize_text_field( $hooks ) ),true );
        foreach( $removed_hooks as $hook_name => $arr ){
          ?>
          <tr>
          <?php
          foreach( $arr as $arr2 ){
            ?>
            <td class="eos-block-on-hover">
              <div style="position:relative">
                <?php echo esc_html( $hook_name ); ?>
                <div class="fdp-hooks-global-actions eos-hidden" data-post_id="<?php echo esc_attr( $arr2[2] ); ?>" data-hook_name="<?php echo esc_attr( $hook_name ); ?>" data-function_name="<?php echo esc_attr( $arr2[0] ); ?>">
                  <a href="#" class="fdp-hooks-global-delete"><?php esc_html_e( 'Delete','eos-dp-pro' ); ?></a>
                </div>
              </div>
            </td>
            <td><?php echo esc_html( $arr2[0] ); ?></td>
            <td><?php echo esc_html( $arr2[1] ); ?></td>
            <td>
                <?php
                $id = $arr2[2];
                if( function_exists( 'eos_scfm_related_desktop_id' ) ){
                  $desktop_id = eos_scfm_related_desktop_id( $arr2[2] );
                  if( $desktop_id > 0 ){
                    $id = $desktop_id;
                    echo '<span class="dashicons dashicons-smartphone"></span> ';
                  }
                }
                ?>
                <a href="<?php echo esc_url( add_query_arg( array( 'fdp-hooks' => 'actions','hook_name' => $hook_name ),get_permalink( $arr2[2] ) ) ); ?>" target="_blank" >
                <?php echo esc_html( get_the_title( $id ) ); ?>
              </a>
            </td>
          </tr>
          <?php
          }
        }
      }
      ?>
      </tbody>
    </table>
    <?php
  }
}
