<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//It adds the Main Settings section
function eos_dp_pro_settings_callback(){
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	$opts = isset( $opts['eos_dp_general_setts'] ) ? $opts['eos_dp_general_setts'] : array();
	$dev = substr( md5( sanitize_text_field( $_SERVER['HTTP_HOST'] ) ),0,8 );
	$dev_url = esc_url( add_query_arg( 'fdp-dev',$dev,get_home_url() ) );
	wp_enqueue_script( 'fdp-pro-settings',EOS_DP_SETTINGS_JS_URL,array( 'eos-dp-backend' ),true );
	wp_localize_script( 'fdp-pro-settings','fdp_setts_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'action' => 'eos_dp_pro_save_settings','opts_key' => 'eos_dp_pro_settings' ) );

	eos_dp_navigation();
	?>
	<section class="eos-dp-section">
		<div id="fdp-after-plugin-activation" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'After activating a new plugin.','eos-dp-pro' ); ?></h2>
			<p>
				<select id="default_plugin_activation" class="fdp-opt">
					<option value="activate_everywhere"<?php echo isset( $opts['default_plugin_activation'] ) && 'activate_everywhere' === $opts['default_plugin_activation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Activate it everywhere in the FDP settings.','eos-dp-pro' ); ?></option>
					<option value="deactivate_everywhere"<?php echo isset( $opts['default_plugin_activation'] ) && 'deactivate_everywhere' === $opts['default_plugin_activation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Deactivate it everywhere in the FDP settings.','eos-dp-pro' ); ?></option>
				</select>
			</p>
			<p>
				<select id="notification_after_plugin_activation" class="fdp-opt">
					<option value="no_action"<?php echo !isset( $opts['notification_after_plugin_activation'] ) || 'no_action' === $opts['notification_after_plugin_activation'] ? ' selected' : ''; ?>><?php esc_html_e( "Don't send any notification.","eos-dp-pro" ); ?></option>
					<option value="send_email"<?php echo isset( $opts['notification_after_plugin_activation'] ) && 'send_email' === $opts['notification_after_plugin_activation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Send a notification via email.','eos-dp-pro' ); ?></option>
					<option value="send_email_name_user"<?php echo isset( $opts['notification_after_plugin_activation'] ) && 'send_email_name_user' === $opts['notification_after_plugin_activation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Send a notification via email and mention who activated it.','eos-dp-pro' ); ?></option>
				</select>
			</p>
		</div>
		<hr />
		<div id="fdp-after-plugin-dedeactivation" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'After deactivating a plugin.','eos-dp-pro' ); ?></h2>
			<p>
				<select id="notification_after_plugin_deactivation" class="fdp-opt">
					<option value="no_action"<?php echo !isset( $opts['notification_after_plugin_deactivation'] ) || 'no_action' === $opts['notification_after_plugin_deactivation'] ? ' selected' : ''; ?>><?php esc_html_e( "Don't send any notification.","eos-dp-pro" ); ?></option>
					<option value="send_email"<?php echo isset( $opts['notification_after_plugin_deactivation'] ) && 'send_email' === $opts['notification_after_plugin_deactivation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Send a notification via email.','eos-dp-pro' ); ?></option>
					<option value="send_email_name_user"<?php echo isset( $opts['notification_after_plugin_deactivation'] ) && 'send_email_name_user' === $opts['notification_after_plugin_deactivation'] ? ' selected' : ''; ?>><?php esc_html_e( 'Send a notification via email and mention who deactivated it.','eos-dp-pro' ); ?></option>
				</select>
			</p>
		</div>
		<?php if( function_exists( 'wp_after_insert_post' ) ){ ?>
		<div id="fdp-after-post-save" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'After saving a single post.','eos-dp-pro' ); ?></h2>
			<select id="after_saving_post" class="fdp-opt">
				<option value="check"<?php echo !isset( $opts['after_saving_post'] ) || ( isset( $opts['after_saving_post'] ) && 'check' === $opts['after_saving_post'] ) ? ' selected' : ''; ?>><?php esc_html_e( 'Check if the right plugins are disabled.','eos-dp-pro' ); ?></option>
				<option value="no_check"<?php echo isset( $opts['after_saving_post'] ) && 'no_check' === $opts['after_saving_post'] ? ' selected' : ''; ?>><?php esc_html_e( "Don't check anything.","eos-dp-pro" ); ?></option>
			</select>
		</div>
		<div id="fdp-after-post-save-notification" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'If after saving a single post FDP detects wrong disabled plugins.','eos-dp-pro' ); ?></h2>
			<select id="after_saving_notification" class="fdp-opt">
				<option value="no_action"<?php echo isset( $opts['after_saving_notification'] ) && 'no_action' === $opts['after_saving_notification'] ? ' selected' : ''; ?>><?php esc_html_e( "Don't show any warning","eos-dp-pro" ); ?></option>
				<option value="backend_notice"<?php echo !isset( $opts['after_saving_notification'] ) || ( isset( $opts['after_saving_notification'] ) && 'backend_notice' === $opts['after_saving_notification'] ) ? ' selected' : ''; ?>><?php esc_html_e( 'Display a warning in the backend.','eos-dp-pro' ); ?></option>
				<option value="backend_notice_and_email"<?php echo isset( $opts['after_saving_notification'] ) && 'backend_notice_and_email' === $opts['after_saving_notification'] ? ' selected' : ''; ?>><?php esc_html_e( 'Show a warning in the backend and send an email.','eos-dp-pro' ); ?></option>
			</select>
		</div>
		<hr />
		<?php } ?>
		<div id="notifications_email-wrp" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'Send notifications to:','eos-dp-pro' ); ?></h2>
			<span style="padding:6px;background:#fff;border:1px solid"><span style="padding:6px 0" class="dashicons dashicons-email"></span><input type="email" style="border:none;background:transparent" id="notifications_email" class="fdp-opt" required value="<?php echo isset( $opts['notifications_email'] ) && sanitize_email( $opts['notifications_email'] ) === $opts['notifications_email'] ? $opts['notifications_email'] : get_site_option( 'admin_email' ); ?>" /></span>
		</div>
		<hr />
		<div id="dependencies-wrp" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'Dependencies','eos-dp-pro' ); ?></h2>
			<input type="checkbox" id="dependencies" class="fdp-opt" value="on"<?php echo !isset( $opts['dependencies'] ) ||  '1' === $opts['dependencies'] ? ' checked' : ''; ?>/>
			<span><?php esc_html_e( 'If checked (recommended) FDP will try to prevent the deactivation of a plugin if one of its add-ons is active.','eps-dp-pro' ); ?></span>
		</div>
		<hr />
		<div id="dev_mode-wrp" class="eos-dp-mb-32">
			<h2><?php esc_html_e( 'Development mode on frontend','eos-dp-pro' ); ?></h2>
			<input type="checkbox" id="dev_mode" class="fdp-opt" value="on"<?php echo !isset( $opts['dev_mode'] ) ||  '1' !== $opts['dev_mode'] ? '' : ' checked'; ?>/>
			<span><?php echo wp_kses( sprintf( __( 'If the Development mode is active, FDP will work on the frontend only by adding the query argument ?fdp-dev=%s to the URL, e.g. %s%s%s','eps-dp-pro' ),$dev,'<a href="'.$dev_url.'" target="_blank">',$dev_url,'</a>' ),array( 'a' => array( 'href' => array(),'target' => '_blank' ) ) ); ?></span>
		</div>
	</section>
	<hr />
	<?php
	if( function_exists( 'eos_dp_save_button' ) && current_user_can( 'activate_plugins' ) ){
		eos_dp_save_button();
	}
	wp_nonce_field( 'fdp_setts_nonce','fdp_setts_nonce' );
	wp_enqueue_script( 'fdp-pro-settings',EOS_DP_PLUGIN_URL.'/admin/assets/js/fdp-settings-1.1.js',array(),true );
	wp_localize_script( 'fdp-pro-settings','fdp_setts_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'action' => 'eos_dp_pro_save_settings','opts_key' => 'eos_dp_general_setts' ) );
}
