<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

wp_enqueue_script( 'fdp-settings',EOS_DP_SETTINGS_JS_URL,array(),true );
wp_localize_script( 'fdp-settings','fdp_setts_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'action' => 'eos_dp_pro_save_settings','opts_key' => 'eos_dp_license' ) );
wp_nonce_field( 'fdp_setts_nonce','fdp_setts_nonce' );
wp_nonce_field( 'fdp_check_license_status','fdp_check_license_status' );
eos_dp_navigation();
$main_opts = eos_dp_get_option( 'eos_dp_pro_main' );
$licenseA = isset( $main_opts['eos_dp_license'] ) ? $main_opts['eos_dp_license'] : false;
$license_email = $licenseA && isset( $licenseA['fdp-license-email'] ) ? sanitize_email( $licenseA['fdp-license-email'] ): '';
$license_key = $licenseA && isset( $licenseA['fdp-license-key'] ) ? esc_attr( $licenseA['fdp-license-key'] ) : '';
?>
<style id="fdp-license-page">
.eos-dp-btn-wrp {
    position: static;
}
</style>
<section id="fdp-license" class="eos-dp-section">
  <div class="eos-dp-margin-top-32">
    <h2><?php esc_html_e( 'License.','eos-dp' ); ?></h2>
    <?php do_action( 'eos_dp_before_wrapper' ); ?>
    <div id="eos-dp-wrp">
      <p><label for="fdp-license-email"><?php esc_html_e( 'License Email' ); ?></label></p>
      <o><input type="email" name="fdp-license-emmail" id="fdp-license-email" class="fdp-opt regular-text" value="<?php echo sanitize_email( $license_email ); ?>" /></p>
      <p class="eos-dp-margin-top-32"><label for="fdp-license-key"><?php esc_html_e( 'License Key' ); ?></label></p>
      <p><input type="text" name="fdp-license-key" id="fdp-license-key" class="fdp-opt regular-text" value="<?php echo esc_attr( $license_key ); ?>" /></p>
    </div>
    <div class="eos-dp-margin-top-32">
      <span id="fdp-check-license-status" class="button"><?php esc_html_e( 'Check Status','eos-dp-pro' ); ?></span>
      <div id="fdp-license-status-msg" class="eos-hidden" style="margin-top:32px">
        <div id="fdp-lic-title"></div>
        <div id="fdp-lic-is_valid"></div>
        <div id="fdp-lic-updates"></div>
        <div id="fdp-lic-support"></div>
      </div>
    </div>
  </div>
  <?php eos_dp_save_button(); ?>
  <script>
  document.getElementById('fdp-check-license-status').addEventListener('click',function(){
    var data = {},btn = this,msg = document.getElementById('fdp-license-status-msg');
    btn.className = btn.className.replace(' eos-dp-progress','') + ' eos-dp-progress';
    msg.className = 'eos-hidden';
    data['license_code'] = document.getElementById('fdp-license-key').value;
    data['license_email'] = document.getElementById('fdp-license-email').value;
    data['nonce'] = document.getElementById('fdp_check_license_status').value;
    var xhr = fdp_setts_sendData(data,'eos_dp_check_license_status');
    xhr.onload = function(){
      if('' === xhr.response){
        alert('Something went wrong during the saving process.');
        return false;
      }
      var obj = JSON.parse(xhr.response);
      if('undefined' !== typeof(obj.error)){
        alert(obj.error);
        btn.className = btn.className.replace(' eos-dp-progress','');
        return false;
      }
      msg.className = '';
      if('undefined' !== typeof(obj.is_valid)){
        document.getElementById('fdp-lic-is_valid').innerHTML = obj.is_valid;
      }
      if('undefined' !== typeof(obj.updates)){
        document.getElementById('fdp-lic-updates').innerHTML = obj.updates;
      }
      if('undefined' !== typeof(obj.support)){
        document.getElementById('fdp-lic-support').innerHTML = obj.support;
      }
      btn.className = btn.className.replace(' eos-dp-progress','');
    }
  });
  </script>
</section>
