<?php
/**
 * Remove cookies from static resources

 * @package Freesoul Deactivate Plugins
 */

defined( 'ABSPATH' ) || exit; // Exit if accessed directly

add_action( 'wp_head','eos_dp_pro_rcfsr_ob_start',0 );
add_action( 'wp_footer','eos_dp_pro_rcfsr_ob_start',0 );

function eos_dp_pro_rcfsr_ob_start(){
    ob_start();
}

add_action( 'wp_head','eos_dp_pro_rcfsr_add_crossorigin_to_head_and_footer',PHP_INT_MAX );
add_action( 'wp_footer','eos_dp_pro_rcfsr_add_crossorigin_to_head_and_footer',PHP_INT_MAX );

function eos_dp_pro_rcfsr_add_crossorigin_to_head_and_footer(){
    $html = ob_get_clean();
    $html = eos_dp_pro_rcfsr_add_crossorigin_to_tag( $html,array( 'script','link' ) );
    echo $html;
}

add_filter( 'the_content',function( $content ){
    $content = eos_dp_pro_rcfsr_add_crossorigin_to_tag( $content,array( 'img' ) );
    return $content;
} );

function eos_dp_pro_rcfsr_add_crossorigin_to_tag( $html,$tags ){
    foreach( $tags as $tag ){
        $pattern = in_array( $tag,array( 'script' ) ) ? sprintf( '/<%s((?!crossorigin).)+%s>/i',$tag,$tag ) : sprintf( '/<%s((?!crossorigin).)+>/i',$tag );
        preg_match_all( $pattern,$html,$arr );
        if( $arr && is_array( $arr ) && isset( $arr[0] ) ){
            foreach( $arr[0] as $l ){
                if( false !== strpos( $l,'src' ) || false !== strpos( $l,'href' ) ){
                    $nl = str_replace( '<'.$tag,'<'.$tag.' crossorigin="anonymous"',$l );
                    $html = str_replace( $l,$nl,$html );
                }
            }
        }
    }
    return $html;
}
